/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * Development of this software was sponsored by the Office of Biological  *
 * and Environmental Research of the U.S. Department of Energy's Office    *
 * of Science.                                                             *
 *                                                                         *
 * Copyright 2011 UChicago Argonne, LLC.                                   *
 *                                                                         *
 * Licensed under the Apache License, Version 2.0 (the "License"); you     *
 * may not use this file except in compliance with the License.  You may   *
 * obtain a copy of the License at                                         * 
 *                                                                         *
 *   http://www.apache.org/licenses/LICENSE-2.0                            *
 *                                                                         *
 * Unless required by applicable law or agreed to in writing, software     *
 * distributed under the License is distributed on an "AS IS" BASIS,       *
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or         *
 * implied.  See the License for the specific language governing           *
 * permissions and limitations under the License.                          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "ParCALFuncs.h"
#include "PNclUtils.h"
#define MPICH_SKIP_MPICXX
#include "mpi.h"
#ifndef MPI_INCLUDED
#define MPI_INCLUDED
#endif

extern MPI_Comm pcal_gcomm;
int PNclIsLocalNode(void )
{
	static int is_local_node = -1;
	if(is_local_node == -1){
		int rank=-1, retval;
		retval = MPI_Comm_rank(pcal_gcomm, &rank);
		if(retval != MPI_SUCCESS){
			NhlPError(NhlFATAL, NhlEUNKNOWN, "Error obtaining MPI rank of the process");
		}
		is_local_node = (rank == 0) ? 1 : 0;
	}
	return is_local_node;
}

void PNclSync(void )
{
	MPI_Barrier(pcal_gcomm);
}
